/*******************************************************************************

  Copyright (C) 2010, 2013 LIFIA - Facultad de Informatica - Univ. Nacional de La Plata

********************************************************************************

  This file is part of DTV-canvas implementation.

    DTV-canvas is free software: you can redistribute it and/or modify it
  under the terms of the GNU Lesser General Public License as published by the Free
  Software Foundation, either version 2 of the License.

    DTV-canvas is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
  A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License along with
  this program. If not, see <http://www.gnu.org/licenses/>.

********************************************************************************

  Este archivo es parte de la implementación de DTV-canvas.

    DTV-canvas es Software Libre: Ud. puede redistribuirlo y/o modificarlo
  bajo los términos de la Licencia Pública General Reducida GNU como es publicada por la
  Free Software Foundation, según la versión 2 de la licencia.

    DTV-canvas se distribuye esperando que resulte de utilidad, pero SIN NINGUNA
  GARANTÍA; ni siquiera la garantía implícita de COMERCIALIZACIÓN o ADECUACIÓN
  PARA ALGÚN PROPÓSITO PARTICULAR. Para más detalles, revise la Licencia Pública
  General Reducida GNU.

    Ud. debería haber recibido una copia de la Licencia Pública General Reducida GNU
  junto a este programa. Si no, puede verla en <http://www.gnu.org/licenses/>.

*******************************************************************************/

#pragma once

#include <string>
#include <vector>

#define DEFAULT_FONT "Tiresias"

namespace canvas {

class Font
{
public:
	Font();
	Font( const std::vector<std::string> &families, size_t size, bool bold=false, bool italic=false, bool smallCaps=false );
	Font( const char *familySeparetedByComa, size_t size, bool bold=false, bool italic=false, bool smallCaps=false );	
	virtual ~Font();
	
	void families( const std::vector<std::string> &families );
	std::string familiesAsString() const;
	void size( size_t size );
	void bold( bool enable );
	void italic( bool enable );
	void smallCaps( bool enable );

	const std::vector<std::string>& families() const;
	size_t size() const;
	bool bold() const;
	bool italic() const;
	bool smallCaps() const;

	bool operator==(const Font &font) const;
	bool operator!=(const Font &font) const;
	bool operator<(const Font &font) const;

protected:
	void addDefault();
	
private:
	std::vector<std::string> _families;
	size_t _size;
	bool _bold;
	bool _italic;
	bool _smallCaps;
};

}

