/*******************************************************************************

  Copyright (C) 2010, 2013 LIFIA - Facultad de Informatica - Univ. Nacional de La Plata

********************************************************************************

  This file is part of DTV-luaz implementation.

    DTV-luaz is free software: you can redistribute it and/or modify it
  under the terms of the GNU Lesser General Public License as published by the Free
  Software Foundation, either version 2 of the License.

    DTV-luaz is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
  A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License along with
  this program. If not, see <http://www.gnu.org/licenses/>.

********************************************************************************

  Este archivo es parte de la implementación de DTV-luaz.

    DTV-luaz es Software Libre: Ud. puede redistribuirlo y/o modificarlo
  bajo los términos de la Licencia Pública General Reducida GNU como es publicada por la
  Free Software Foundation, según la versión 2 de la licencia.

    DTV-luaz se distribuye esperando que resulte de utilidad, pero SIN NINGUNA
  GARANTÍA; ni siquiera la garantía implícita de COMERCIALIZACIÓN o ADECUACIÓN
  PARA ALGÚN PROPÓSITO PARTICULAR. Para más detalles, revise la Licencia Pública
  General Reducida GNU.

    Ud. debería haber recibido una copia de la Licencia Pública General Reducida GNU
  junto a este programa. Si no, puede verla en <http://www.gnu.org/licenses/>.

*******************************************************************************/

#pragma once

#include <string>
#include <map>
#include <queue>

typedef struct lua_State lua_State;

namespace zapper {
	class Zapper;
}

namespace luaz {

class MainWindow;

class UI {
public:
	UI( const std::string &name, bool supportWidgets, const std::string &icon=std::string("") );
	virtual ~UI();

	int run( const std::string &script );
	void stop();

	void setEnvironmentVar( const std::string &name, const std::string &value );

protected:
	//	Aux lua
	void runScript( const std::string &script );

	//	Initialize
	bool initialize();
	void finalize();
	void addServices();

	void loadEnvironmentVars();

private:
	std::string _name;
	std::string _icon;
	zapper::Zapper *_zapper;
	typedef std::pair<std::string, std::string> variable;
	std::vector<variable> _environmentVars;
	lua_State *_lState;
	MainWindow *_mainWindow;
	bool _supportWidgets;
};

}

