/*******************************************************************************

  Copyright (C) 2010, 2011 LIFIA - Facultad de Informatica - Univ. Nacional de La Plata

********************************************************************************

  This file is part of DTV-connector implementation.

    DTV-connector is free software: you can redistribute it and/or modify it
  under the terms of the GNU Lesser General Public License as published by the Free
  Software Foundation, either version 2 of the License.

    DTV-connector is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
  A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License along with
  this program. If not, see <http://www.gnu.org/licenses/>.

********************************************************************************

  Este archivo es parte de la implementación de DTV-connector.

    DTV-connector es Software Libre: Ud. puede redistribuirlo y/o modificarlo
  bajo los términos de la Licencia Pública General Reducida GNU como es publicada por la
  Free Software Foundation, según la versión 2 de la licencia.

    DTV-connector se distribuye esperando que resulte de utilidad, pero SIN NINGUNA
  GARANTÍA; ni siquiera la garantía implícita de COMERCIALIZACIÓN o ADECUACIÓN
  PARA ALGÚN PROPÓSITO PARTICULAR. Para más detalles, revise la Licencia Pública
  General Reducida GNU.

    Ud. debería haber recibido una copia de la Licencia Pública General Reducida GNU
  junto a este programa. Si no, puede verla en <http://www.gnu.org/licenses/>.

*******************************************************************************/
#pragma once

#include "../language.h"

namespace tuner {

//	Charset implemented by
//		ETSI EN 300 468 V1.11.1 Annex A (TODO: Ignored)
inline int parseLanguage( Language &lang, BYTE *data ) {
	char ptr[4];
	for (int i=0; i<3; i++) {
		ptr[i] = data[i];
	}
	ptr[3] = '\0';
	lang = ptr;
	return 3;
}

inline int parseText( std::string &var, BYTE *ptr, int len ) {
	if (len > 0) {
		if (isprint(*ptr)) {
			var.assign( (char *)ptr, len );
		}
		else {
			var.assign( (char *)(ptr+1), len-1 );
		}
	}
	else {
		var.clear();
	}
	return len;
}

inline int parseText( std::string &var, BYTE *ptr ) {
	BYTE len = GET_BYTE(ptr);
	if (len) {
		if (isprint(*(ptr+1))) {
			var.assign( (char *)(ptr+1), len );
		}
		else {
			var.assign( (char *)(ptr+2), len-1 );
		}
	}
	else {
		var.clear();
	}
	return len+1;
}

}

